//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 7-1
//
// Calculates the weight of water in a complex aquarium with dimensions
// entered by the user.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#define PI 3.14
#define WEIGHT 6.4279

void get_size_data(int32 & cW, int32 & cL, int32 & cH, int32 & tD, int32 & tL);
int32 calculate_weight(int32 cW, int32 cL, int32 cH, int32 tD, int32 tL);
int32 enter_feet_inches();
int32 find_area_of_rectangle(int32 length, int32 width);
int32 find_volume_of_cuboid(int32 area, int32 height);
int32 find_area_of_circle(int32 diam);
int32 find_volume_of_tube(int32 area, int32 lenght);
int32 volume_to_weight(int32 volume);

void main(void){
   
   int32 cW, cL, cH, tD, tL;
   
   while ( TRUE ) {
      get_size_data ( cW, cL, cH, tD, tL );
      
      printf("Weight of water in that tank is: %u\r\n", (int)calculate_weight ( cW, cL,
      cH, tD, tL ));
   }

   
   for(;;);
}

void get_size_data(int32 & cW, int32 & cL, int32 & cH, int32 & tD, int32 & tL){
   printf("Begin with Cuboid Width\r\n");
   cW = enter_feet_inches ( ) ;
   
   printf("Good, now the Length\r\n");
   CL = enter_feet_inches ( ) ;
   
   printf("Great, now the Height\r\n");
   cH = enter_feet_inches ( ) ;
   
   printf("Perfect, now the Tube Diameter\r\n");
   tD = enter_feet_inches ( ) ;
   
   printf("Last one, the Tube Length\r\n");
   tL = enter_feet_inches ( ) ;
}

int32 calculate_weight(int32 cW, int32 cL, int32 cH, int32 tD, int32 tL){
   return volume_to_weight ( ( 2 * find_volume_of_cuboid (
   find_area_of_rectangle ( cL, cW ), cH ) ) + find_volume_of_tube ( 
   find_area_of_circle ( tD ) , tL ) );
}

int32 enter_feet_inches(){
   int32 feet = 0, inches = 0;
   
   printf("Enter feet: ");
   feet = get_long_usb();
   printf("\r\n");
   
   printf("Enter inches: ");
   inches = get_long_usb();
   printf("\r\n");
   
   return ( feet * 12 ) + inches;
}

int32 find_area_of_rectangle(int32 length, int32 width){
   return length * width;
}

int32 find_volume_of_cuboid(int32 area, int32 height){
   return area * height;
}

int32 find_area_of_circle(int32 diam){
   return ( PI * ( diam * diam ) ) / 4;
}

int32 find_volume_of_tube(int32 area, int32 length){
   return area * length;
}

int32 volume_to_weight(int32 volume){
   return volume * WEIGHT;
}

