//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 7-1 #3
//
// Calculates the weight of water in a complex aquarium with dimensions
// entered by the user. Each function of the calculation also passes back an
// error flag. The flag should be set if the calculation would result in a
// number too big to fit in an int32. If an error occurs the calculation
// should stop and an error should be sent back to the user.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#define PI 3.14
#define WEIGHT 6.4279

void get_size_data(int32 & cW, int32 & cL, int32 & cH, int32 & tD, int32 & tL);
int32 calculate_weight(int32 cW, int32 cL, int32 cH, int32 tD, int32 tL);
int32 enter_feet_inches();
int32 find_area_of_rectangle(int32 length, int32 width, int & error);
int32 find_volume_of_cuboid(int32 area, int32 height, int & error);
int32 find_area_of_circle(int32 diam, int & error);
int32 find_volume_of_tube(int32 area, int32 lenght, int & error);
int32 volume_to_weight(int32 volume, int & error);

void main(void){
   
   int32 cW, cL, cH, tD, tL;
   
   //usb_init();
   
   while ( TRUE ) {
      get_size_data ( cW, cL, cH, tD, tL );
      
      printf( "Weight of water in that tank is: %u\r\n", (int)calculate_weight ( cW, cL,
      cH, tD, tL ));
   }

   
   for(;;);
}

void get_size_data(int32 & cW, int32 & cL, int32 & cH, int32 & tD, int32 & tL){
   printf("Begin with Cuboid Width\r\n");
   cW = enter_feet_inches ( ) ;
   
   printf("Good, now the Length\r\n");
   CL = enter_feet_inches ( ) ;
   
   printf("Great, now the Height\r\n");
   cH = enter_feet_inches ( ) ;
   
   printf("Perfect, now the Tube Diameter\r\n");
   tD = enter_feet_inches ( ) ;
   
   printf("Last One, the Tube Length\r\n");
   tL = enter_feet_inches ( ) ;
}

int32 calculate_weight(int32 cW, int32 cL, int32 cH, int32 tD, int32 tL){
   int error=0;
   
   int32 rA, cV, dCV, cA, tV, result;
   
   while(!error)
   {
      rA = find_area_of_rectangle(Cl, cW, error);
      if(error)
      {
         printf("ERROR IN REC CALCULATIONS\r\n");
         break;
      }
      cV = find_volume_of_cuboid(rA, cH, error);
      if(error)
      {
         printf("ERROR IN CUB CALCULATIONS\r\n");
         break;
      }
      dCV = cV+cV;
      if(dCV <= cV)   // Overflow occured
      {
         printf("ERROR IN DUB CALCULATIONS\r\n");
         break;
      }
      cA = find_area_of_circle(tD, error);
      if(error)
      {
         printf("ERROR IN CIR CALCUATIONS\r\n");
         break;
      }
      tV = find_volume_of_tube(cA, tL, error);
      if(error)
      {
         printf("ERROR IN TUB CALCULATIONS\r\n");
         break;
      }
      result = tV+dCV;
      if((result <= tV) || (result <= dCV))
      {
         printf("ERROR IN VOL CALCULATIONS\r\n");
         break;
      }
      result = volume_to_weight(result, error);
      if(error)
      {
         printf("ERROR IN WEI CALCULATIONS\r\n");
         break;
      }
      return result;
   }
   return error;
}

int32 enter_feet_inches(){
   int32 feet = 0, inches = 0;
   
   printf("Enter feet: ");
   feet = get_int_usb();
   printf("\r\n");
   
   printf(usb_cdc_putc, "Enter inches: ");
   inches = get_int_usb();
   printf("\r\n");
   
   return ( feet * 12 ) + inches;
}

int32 find_area_of_rectangle(int32 length, int32 width, int & error){
   int32 retVal = length*width;
   if((retVal <= length) || (retVal <= width))
      error = -1;
   return retVal;;
}

int32 find_volume_of_cuboid(int32 area, int32 height, int & error){
   int32 retVal = area*height;
   if((retVal <= area) || (retVal <= height))
      error = -2;
   return retVal;
}

int32 find_area_of_circle(int32 diam, int & error){
   int32 retVal = (PI*(diam*diam))/4;
   if(retVal <= diam)
      error = -3;
   return retVal;;
}

int32 find_volume_of_tube(int32 area, int32 length, int & error){
   int32 retVal = area*length;
   if((retVal <=area) || (retVal <= length))
      error = -4;
   return retVal;;
}

int32 volume_to_weight(int32 volume, int & error){
   int32 retVal = volume*WEIGHT;
   if((retVal <= volume) || (retVal <= WEIGHT))
      error = -5;
   return retVal;
}

